# Class EmbeddedServletOptions

java.lang.Object
org.apache.jasper.EmbeddedServletOptions

All Implemented Interfaces:
  `Options`

public final class EmbeddedServletOptions extends Object implements Options
A class to hold all init parameters specific to the JSP engine.

Author:
  Anil K. Vijendran, Hans Bergsten, Pierre Delisle

## Field Summary

Fields
Modifier and Type
Field
Description
`boolean`
`fork`
Should Ant fork its java compiles of JSP pages.

## Constructor Summary

Constructors
Constructor
Description
`EmbeddedServletOptions(ServletConfig config, ServletContext context)`
Create an EmbeddedServletOptions object using data available from ServletConfig and ServletContext.

## Method Summary

Modifier and Type
Method
Description
`boolean`
`genStringAsCharArray()`
Indicates whether text strings are to be generated as char arrays.
`Map<String, TagLibraryInfo>`
`getCache()`
The web-application wide cache for the TagLibraryInfo tag library descriptors, used if `Options.isCaching()` returns `true`.
`int`
`getCheckInterval()`
`boolean`
`getClassDebugInfo()`
`String`
`getClassPath()`
`String`
`getCompiler()`
Compiler to use.
`String`
`getCompilerClassName()`
`String`
`getCompilerSourceVM()`
`String`
`getCompilerTargetVM()`
`boolean`
`getDevelopment()`
Main development flag, which enables detailed error reports with sources, as well automatic recompilation of JSPs and tag files.
`boolean`
`getDisplaySourceFragment()`
`boolean`
`getErrorOnUseBeanInvalidClassAttribute()`
Returns true if Jasper issues a compilation error instead of a runtime Instantiation error if the class attribute specified in useBean action is invalid.
`boolean`
`getFork()`
The boolean flag to tell Ant whether to fork JSP page compilations.
`String`
`getIeClassId()`
Deprecated.
`String`
`getJavaEncoding()`
`JspConfig`
`getJspConfig()`
`int`
`getJspIdleTimeout()`
`boolean`
`getKeepGenerated()`
`boolean`
`getMappedFile()`
`int`
`getMaxLoadedJsps()`
The maximum number of loaded jsps per web-application.
`int`
`getModificationTestInterval()`
`String`
`getProperty(String name)`
`boolean`
`getQuoteAttributeEL()`
`boolean`
`getRecompileOnFail()`
`File`
`getScratchDir()`
`boolean`
`getStrictQuoteEscaping()`
`TagPluginManager`
`getTagPluginManager()`
`TldCache`
`getTldCache()`
The cache that maps URIs, resource paths and parsed TLD files for the various tag libraries 'exposed' by the web application.
`TrimSpacesOption`
`getTrimSpaces()`
`String`
`getUseNonstandardTagOptimizations()`
A string containing a comma-separated list of names to which custom tag implementations should be applied.
`boolean`
`isCaching()`
`boolean`
`isPoolingEnabled()`
`boolean`
`isSmapDumped()`
This setting is ignored if suppressSmap() is `true`.
`boolean`
`isSmapSuppressed()`
`boolean`
`isXpoweredBy()`
`void`
`setErrorOnUseBeanInvalidClassAttribute(boolean b)`
`void`
`setProperty(String name, String value)`
`void`
`setQuoteAttributeEL(boolean b)`
`void`
`setTldCache(TldCache tldCache)`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.apache.jasper.Options

`getGeneratedJavaAddTimestamp`

## Field Details

### fork

public boolean fork
Should Ant fork its java compiles of JSP pages.

## Constructor Details

### EmbeddedServletOptions

public EmbeddedServletOptions(ServletConfig config, ServletContext context)
Create an EmbeddedServletOptions object using data available from ServletConfig and ServletContext.

Parameters:
  `config` - The Servlet config
  `context` - The Servlet context

## Method Details

### getProperty

public String getProperty(String name)

### setProperty

public void setProperty(String name, String value)

### setQuoteAttributeEL

public void setQuoteAttributeEL(boolean b)

### getQuoteAttributeEL

public boolean getQuoteAttributeEL()

Specified by:
  `getQuoteAttributeEL` in interface `Options`
Returns:
  `true` if EL expressions used within attributes should have the quoting rules in JSP.1.6 applied to the expression.

### getKeepGenerated

public boolean getKeepGenerated()

Specified by:
  `getKeepGenerated` in interface `Options`
Returns:
  `true` to keep the generated source

### getTrimSpaces

public TrimSpacesOption getTrimSpaces()

Specified by:
  `getTrimSpaces` in interface `Options`
Returns:
  `TrimSpacesOption.TRUE` to remove template text that consists only of whitespace from the output completely, `TrimSpacesOption.SINGLE` to replace such template text with a single space, `TrimSpacesOption.FALSE` to leave such template text unchanged or `TrimSpacesOption.EXTENDED` to remove template text that consists only of whitespace and to replace any sequence of whitespace and new lines within template text with a single new line.

### getUseNonstandardTagOptimizations

public String getUseNonstandardTagOptimizations()
Description copied from interface: `Options`
A string containing a comma-separated list of names to which custom tag implementations should be applied. Unknown or unused tag entries are harmless. Generally defined via an init parameter on the JspServlet.

Specified by:
  `getUseNonstandardTagOptimizations` in interface `Options`
Returns:
  which tags to use

### isPoolingEnabled

public boolean isPoolingEnabled()

Specified by:
  `isPoolingEnabled` in interface `Options`
Returns:
  `true` if tag handler pooling is enabled, `false` otherwise.

### getMappedFile

public boolean getMappedFile()

Specified by:
  `getMappedFile` in interface `Options`
Returns:
  `true` if HTML mapped Servlets are supported.

### getClassDebugInfo

public boolean getClassDebugInfo()

Specified by:
  `getClassDebugInfo` in interface `Options`
Returns:
  `true` if debug information in included in compiled classes.

### getCheckInterval

public int getCheckInterval()

Specified by:
  `getCheckInterval` in interface `Options`
Returns:
  background compile thread check interval in seconds

### getModificationTestInterval

public int getModificationTestInterval()

Specified by:
  `getModificationTestInterval` in interface `Options`
Returns:
  modification test interval.

### getRecompileOnFail

public boolean getRecompileOnFail()

Specified by:
  `getRecompileOnFail` in interface `Options`
Returns:
  `true` if re-compile will occur on a failure.

### getDevelopment

public boolean getDevelopment()
Description copied from interface: `Options`
Main development flag, which enables detailed error reports with sources, as well automatic recompilation of JSPs and tag files. This setting should usually be `false` when running in production.

Specified by:
  `getDevelopment` in interface `Options`
Returns:
  `true` if Jasper is in development mode

### isSmapSuppressed

public boolean isSmapSuppressed()

Specified by:
  `isSmapSuppressed` in interface `Options`
Returns:
  `true` to suppress generation of SMAP info for JSR45 debugging.

### isSmapDumped

public boolean isSmapDumped()
Description copied from interface: `Options`
This setting is ignored if suppressSmap() is `true`.

Specified by:
  `isSmapDumped` in interface `Options`
Returns:
  `true` to write SMAP info for JSR45 debugging to a file.

### genStringAsCharArray

public boolean genStringAsCharArray()
Description copied from interface: `Options`
Indicates whether text strings are to be generated as char arrays.

Specified by:
  `genStringAsCharArray` in interface `Options`
Returns:
  `true` if text strings are to be generated as char arrays, `false` otherwise

### getIeClassId

@Deprecated public String getIeClassId()
Deprecated.
Description copied from interface: `Options`
Gets the class-id value that is sent to Internet Explorer when using <jsp:plugin> tags.

Specified by:
  `getIeClassId` in interface `Options`
Returns:
  Class-id value

### getScratchDir

public File getScratchDir()

Specified by:
  `getScratchDir` in interface `Options`
Returns:
  the work folder

### getClassPath

public String getClassPath()

Specified by:
  `getClassPath` in interface `Options`
Returns:
  the classpath used to compile generated Servlets

### isXpoweredBy

public boolean isXpoweredBy()

Specified by:
  `isXpoweredBy` in interface `Options`
Returns:
  `true` to generate a X-Powered-By response header.

### getCompiler

public String getCompiler()
Description copied from interface: `Options`
Compiler to use.

If `null` (the default), the java compiler from Eclipse JDT project, bundled with Tomcat, will be used. Otherwise, the `javac` task from Apache Ant will be used to call an external java compiler and the value of this option will be passed to it. See Apache Ant documentation for the possible values.

Specified by:
  `getCompiler` in interface `Options`
Returns:
  the compiler name

### getCompilerTargetVM

public String getCompilerTargetVM()

Specified by:
  `getCompilerTargetVM` in interface `Options`
Returns:
  the compiler target VM, e.g. 1.8.

### getCompilerSourceVM

public String getCompilerSourceVM()

Specified by:
  `getCompilerSourceVM` in interface `Options`
Returns:
  the compiler source VM, e.g. 1.8.

### getCompilerClassName

public String getCompilerClassName()

Specified by:
  `getCompilerClassName` in interface `Options`
Returns:
  Jasper Java compiler class to use.

### getErrorOnUseBeanInvalidClassAttribute

public boolean getErrorOnUseBeanInvalidClassAttribute()
Description copied from interface: `Options`
Returns true if Jasper issues a compilation error instead of a runtime Instantiation error if the class attribute specified in useBean action is invalid.

Specified by:
  `getErrorOnUseBeanInvalidClassAttribute` in interface `Options`
Returns:
  `true` to get an error

### setErrorOnUseBeanInvalidClassAttribute

public void setErrorOnUseBeanInvalidClassAttribute(boolean b)

### getTldCache

public TldCache getTldCache()
Description copied from interface: `Options`
The cache that maps URIs, resource paths and parsed TLD files for the various tag libraries 'exposed' by the web application. A tag library is 'exposed' either explicitly in web.xml or implicitly via the uri tag in the TLD of a taglib deployed in a jar file (WEB-INF/lib).

Specified by:
  `getTldCache` in interface `Options`
Returns:
  the instance of the TldCache for the web-application.

### setTldCache

public void setTldCache(TldCache tldCache)

### getJavaEncoding

public String getJavaEncoding()

Specified by:
  `getJavaEncoding` in interface `Options`
Returns:
  Java platform encoding to generate the JSP page servlet.

### getFork

public boolean getFork()
Description copied from interface: `Options`
The boolean flag to tell Ant whether to fork JSP page compilations.

Is used only when Jasper uses an external java compiler (wrapped through a `javac` Apache Ant task).

Specified by:
  `getFork` in interface `Options`
Returns:
  `true` to fork a process during compilation

### getJspConfig

public JspConfig getJspConfig()

Specified by:
  `getJspConfig` in interface `Options`
Returns:
  JSP configuration information specified in web.xml.

### getTagPluginManager

public TagPluginManager getTagPluginManager()

Specified by:
  `getTagPluginManager` in interface `Options`
Returns:
  a Tag Plugin Manager

### isCaching

public boolean isCaching()

Specified by:
  `isCaching` in interface `Options`
Returns:
  `true` is caching is enabled (used for precompilation).

### getCache

public Map<String, TagLibraryInfo> getCache()
Description copied from interface: `Options`
The web-application wide cache for the TagLibraryInfo tag library descriptors, used if `Options.isCaching()` returns `true`.

Using this cache avoids the cost of repeating the parsing of a tag library descriptor XML file (performed by TagLibraryInfoImpl.parseTLD).

Specified by:
  `getCache` in interface `Options`
Returns:
  the Map(String uri, TagLibraryInfo tld) instance.

### getDisplaySourceFragment

public boolean getDisplaySourceFragment()

Specified by:
  `getDisplaySourceFragment` in interface `Options`
Returns:
  `true` to include a source fragment in exception messages.

### getMaxLoadedJsps

public int getMaxLoadedJsps()
Description copied from interface: `Options`
The maximum number of loaded jsps per web-application. If there are more jsps loaded, they will be unloaded. If unset or less than 0, no jsps are unloaded.

Specified by:
  `getMaxLoadedJsps` in interface `Options`
Returns:
  The JSP count

### getJspIdleTimeout

public int getJspIdleTimeout()

Specified by:
  `getJspIdleTimeout` in interface `Options`
Returns:
  the idle time in seconds after which a JSP is unloaded. If unset or less or equal than 0, no jsps are unloaded.

### getStrictQuoteEscaping

public boolean getStrictQuoteEscaping()

Specified by:
  `getStrictQuoteEscaping` in interface `Options`
Returns:
  `true` if the quote escaping required by section JSP.1.6 of the JSP specification should be applied to scriplet expression.